"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Strings_1 = require("../Strings");
var ServiceError_1 = require("../Enumerations/ServiceError");
var ExtensionMethods_1 = require("../ExtensionMethods");
var ServiceRemoteException_1 = require("./ServiceRemoteException");
var ServiceResponseException = (function (_super) {
    __extends(ServiceResponseException, _super);
    function ServiceResponseException(response) {
        _super.call(this, response ? response.ErrorMessage : "", undefined);
        this.response = response;
    }
    Object.defineProperty(ServiceResponseException.prototype, "Response", {
        get: function () { return this.response; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ServiceResponseException.prototype, "ErrorCode", {
        get: function () { return this.response ? this.response.ErrorCode : null; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ServiceResponseException.prototype, "Message", {
        get: function () {
            // Special case for Internal Server Error. If the server returned
            // stack trace information, include it in the exception message.
            if (this.Response.ErrorCode == ServiceError_1.ServiceError.ErrorInternalServerError) {
                var exceptionClass = this.Response.ErrorDetails[ServiceResponseException.ExceptionClassKey];
                var exceptionMessage = this.Response.ErrorDetails[ServiceResponseException.ExceptionMessageKey];
                var stackTrace = this.Response.ErrorDetails[ServiceResponseException.StackTraceKey];
                //if (this.Response.ErrorDetails.TryGetValue(ExceptionClassKey, out exceptionClass) &&
                //    this.Response.ErrorDetails.TryGetValue(ExceptionMessageKey, out exceptionMessage) &&
                //    this.Response.ErrorDetails.TryGetValue(StackTraceKey, out stackTrace)) {
                if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(exceptionClass) && !ExtensionMethods_1.StringHelper.IsNullOrEmpty(exceptionMessage) && !ExtensionMethods_1.StringHelper.IsNullOrEmpty(stackTrace)) {
                    return ExtensionMethods_1.StringHelper.Format(Strings_1.Strings.ServerErrorAndStackTraceDetails, this.Response.ErrorMessage, exceptionClass, exceptionMessage, stackTrace);
                }
            }
            return this.Response.ErrorMessage;
        },
        enumerable: true,
        configurable: true
    });
    ServiceResponseException.ExceptionClassKey = "ExceptionClass";
    ServiceResponseException.ExceptionMessageKey = "ExceptionMessage";
    ServiceResponseException.StackTraceKey = "StackTrace";
    return ServiceResponseException;
}(ServiceRemoteException_1.ServiceRemoteException));
exports.ServiceResponseException = ServiceResponseException;
