"use strict";
var XmlElementNames_1 = require("../Core/XmlElementNames");
var XmlAttributeNames_1 = require("../Core/XmlAttributeNames");
var ServiceError_1 = require("../Enumerations/ServiceError");
//todo: fix this - import Xml = require("System.Xml");
var SoapFaultDetails = (function () {
    function SoapFaultDetails() {
        this.ErrorDetails = {}; //System.Collections.Generic.Dictionary<string, string>;
    }
    //private faultCode: string;
    //private faultString: string;
    //private faultActor: string;
    //private responseCode: ServiceError;
    //private message: string;
    //private errorCode: ServiceError;
    //private exceptionType: string;
    //private lineNumber: number;
    //private positionWithinLine: number;
    //private errorDetails: any;//System.Collections.Generic.Dictionary<string, string>;
    SoapFaultDetails.ParseFromJson = function (obj) {
        var soapFaultDetails = new SoapFaultDetails();
        soapFaultDetails.FaultCode = obj[XmlElementNames_1.XmlElementNames.SOAPFaultCodeElementName];
        soapFaultDetails.FaultString = obj[XmlElementNames_1.XmlElementNames.SOAPFaultStringElementName];
        soapFaultDetails.FaultActor = obj[XmlElementNames_1.XmlElementNames.SOAPFaultActorElementName];
        if (obj[XmlElementNames_1.XmlElementNames.SOAPDetailElementName]) {
            soapFaultDetails.ParseDetailNodeFromJson(obj[XmlElementNames_1.XmlElementNames.SOAPDetailElementName]);
        }
        return soapFaultDetails;
    };
    //Parse(jsonObject: JsonObject): SoapFaultDetails{ throw new Error("SoapFaultDetails.ts - Parse : Not implemented.");}
    SoapFaultDetails.prototype.ParseDetailNodeFromJson = function (obj) {
        if (obj[XmlElementNames_1.XmlElementNames.EwsResponseCodeElementName])
            this.ResponseCode = obj[XmlElementNames_1.XmlElementNames.EwsResponseCodeElementName] || ServiceError_1.ServiceError.ErrorInternalServerError;
        if (obj[XmlElementNames_1.XmlElementNames.EwsMessageElementName])
            this.Message = obj[XmlElementNames_1.XmlElementNames.EwsMessageElementName];
        if (obj[XmlElementNames_1.XmlElementNames.EwsLineElementName])
            this.LineNumber = parseInt(obj[XmlElementNames_1.XmlElementNames.EwsLineElementName]);
        if (obj[XmlElementNames_1.XmlElementNames.EwsPositionElementName])
            this.PositionWithinLine = parseInt(obj[XmlElementNames_1.XmlElementNames.EwsPositionElementName]);
        if (obj[XmlElementNames_1.XmlElementNames.EwsErrorCodeElementName])
            this.ErrorCode = obj[XmlElementNames_1.XmlElementNames.EwsErrorCodeElementName] || ServiceError_1.ServiceError.ErrorInternalServerError;
        if (obj[XmlElementNames_1.XmlElementNames.EwsExceptionTypeElementName])
            this.ExceptionType = obj[XmlElementNames_1.XmlElementNames.EwsExceptionTypeElementName];
        if (obj[XmlElementNames_1.XmlElementNames.MessageXml])
            this.ParseMessageXmlFromJson(obj[XmlElementNames_1.XmlElementNames.MessageXml]);
    };
    SoapFaultDetails.prototype.ParseMessageXmlFromJson = function (obj) {
        if (obj[XmlElementNames_1.XmlElementNames.Value]) {
            var element = XmlElementNames_1.XmlElementNames.Value;
            var messageValues;
            if (Object.prototype.toString.call(obj[element]) === "[object Array]")
                messageValues = obj[element];
            else
                messageValues = [obj[element]];
            for (var i = 0; i < messageValues.length; i++) {
                var messageValue = messageValues[i];
                var name = messageValue[XmlAttributeNames_1.XmlAttributeNames.Name];
                if (name) {
                    var value = messageValue[element];
                    this.ErrorDetails[name] = value;
                }
                this.ErrorDetails;
            }
        }
    };
    SoapFaultDetails.Parse = function (reader, soapNamespace) {
        var soapFaultDetails = new SoapFaultDetails();
        do {
            reader.Read();
            if (reader.NodeType == 1) {
                switch (reader.LocalName) {
                    case XmlElementNames_1.XmlElementNames.SOAPFaultCodeElementName:
                        soapFaultDetails.FaultCode = reader.ReadElementValue();
                        break;
                    case XmlElementNames_1.XmlElementNames.SOAPFaultStringElementName:
                        soapFaultDetails.FaultString = reader.ReadElementValue();
                        break;
                    case XmlElementNames_1.XmlElementNames.SOAPFaultActorElementName:
                        soapFaultDetails.FaultActor = reader.ReadElementValue();
                        break;
                    case XmlElementNames_1.XmlElementNames.SOAPDetailElementName:
                        soapFaultDetails.ParseDetailNode(reader);
                        break;
                    default:
                        break;
                }
            }
        } while (reader.HasRecursiveParent(XmlElementNames_1.XmlElementNames.SOAPFaultElementName));
        return soapFaultDetails;
    };
    SoapFaultDetails.prototype.ParseDetailNode = function (reader) { throw new Error("SoapFaultDetails.ts - ParseDetailNode : Not implemented."); };
    SoapFaultDetails.prototype.ParseMessageXml = function (reader) { throw new Error("SoapFaultDetails.ts - ParseMessageXml : Not implemented."); };
    return SoapFaultDetails;
}());
exports.SoapFaultDetails = SoapFaultDetails;
